/**********************************************************************/
/*   This program is developed by MicroSoft C 5.1		       */
/***********************************************************************/
/*  Demo 1: One P8R8 card demo. 				       */
/***********************************************************************/
#include "P16R16.H"

int main()
{
   int	   i,j;
   WORD    nVal;
   float   fVal;
   WORD    wBoards,wRetVal,wVal;
   WORD    wInData;
   WORD    wTypeID;
   WORD    wAddress0,wAddress1,wAddress2;
   WORD    wAddress3,wAddress4,wAddress5;
   WORD    P16R16_BaseAddress,P8R8_BaseAddress;
   WORD    wP16R16No,wP8R8No;

   clrscr();  // a clear screen function in P16R16.LIB
   gotoxy(1,1);

   /* initiaing PCI-P16R16 card and detect how many P16R16/P8R8 card in PC */
   wRetVal=PCI_DriverInit(&wBoards);
   printf("Threr are %d P180X Cards in this PC\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P16R16/P8R8 card in this PC !!!\n");
      exit(0);
   }

   /* dump every P16R16/P8R8 card's configuration address space */
   for(i=0; i<wBoards; i++)
   {
      wRetVal=PCI_GetConfigAddressSpace(i,&wTypeID,
		     &wAddress0,&wAddress1,&wAddress2,
		     &wAddress3,&wAddress4,&wAddress5);
      if( !wRetVal )
      {
	  switch( wTypeID )
	  {
	     case 0:  printf("==> %02d   Board Name:PCI-P16R16\n",i);
		      P16R16_BaseAddress=wAddress2;
		      wP16R16No++;
		      break;
	     case 1:  printf("==> %02d   Board Name:PCI-P8R8\n",i);
		      P8R8_BaseAddress=wAddress2;
		      wP8R8No++;
		      break;
	     case 2:  printf("==> %02d   Board Name:PCI-TMC12\n",i);
		      break;
	     case 3:  printf("==> %02d   Board Name:PCI-DA16\n",i);
		      break;
	     case 4:  printf("==> %02d   Board Name:PCI-DA8\n",i);
		      break;
	  }
	  printf("  --> Addr0:%04x  |  Addr1:%04x  |  Addr2:%0x\n",
					wAddress0,wAddress1,wAddress2);
	  printf("  --> Addr3:%04x  |  Addr4:%04x  |  Addr5:%0x\n\n",
					wAddress3,wAddress4,wAddress5);
      }
   }

   /* Getting the Driver version */
   wRetVal=PCI_GetDriverVersion(&wVal);
   printf("Driver Version=%x\n",wVal);

   /* call a function to test if exact calling LIB */
   nVal=PCI_ShortSub2(1,2);
   printf("P180X_ShortSub2(1,2) = %d\n",nVal);

   /* call another function to test if exact calling LIB */
   fVal=PCI_FloatSub2(1.0,2.0);
   printf("P180X_FloatSub2(1.0,2.0) = %f\n",fVal);

   if( wP8R8No<1 )
   {
       putch(0x07);
       printf("Please plug one PCI-P8R8 in PC !!!\n");
       exit(0);
   }
   /***********************************/
   /*****   PCI-P8R8 DO/DO demo   *****/
   /***********************************/
   printf("The PCI-P8R8 DO/DI testing !!!\n");
   P8R8_DO(P8R8_BaseAddress,0x0000);	 /* Digital output */
   Delay(30000);     // Delay a little time
   wInData=P8R8_DI(P8R8_BaseAddress);  /* Digital input  */
   printf("Digital Output -> 0000H  |  Digital Input -> %04xH\n",wInData);

   P8R8_DO(P8R8_BaseAddress,0xFFFF);	 /* Digital output */
   Delay(30000);     // Delay a little time
   wInData=P8R8_DI(P8R8_BaseAddress);  /* Digital input  */
   printf("Digital Output -> FFFFH  |  Digital Input -> %04xH\n",wInData);

   P8R8_DO(P8R8_BaseAddress,0x5555);	 /* Digital output */
   Delay(30000);     // Delay a little time
   wInData=P8R8_DI(P8R8_BaseAddress);  /* Digital input  */
   printf("Digital Output -> 5555H  |  Digital Input -> %04xH\n",wInData);

   P8R8_DO(P8R8_BaseAddress,0xAAAA);	 /* Digital output */
   Delay(30000);     // Delay a little time
   wInData=P8R8_DI(P8R8_BaseAddress);  /* Digital input  */
   printf("Digital Output -> AAAAH  |  Digital Input -> %04xH\n",wInData);

   PCI_DriverClose();
   return 0;
}

Delay(int DelayTime)
{
   int	  i,j;
   float  a,b;

   for(i=0;  i<DelayTime; i++)
   {
      for(j=0; j<10; j++)
	 a=2*3.0;
   }
}
