/**********************************************************************/
/*   This program is developed by Microsoft C 5.1		       */
/***********************************************************************/
/*  Demo 4: Two P16R16 cards demo.				       */
/***********************************************************************/
#include "P16R16.H"

int main()
{
   int	   i,j;
   WORD    nVal;
   float   fVal;
   WORD    wBoards,wRetVal,wVal;
   WORD    wInData;
   WORD    wTypeID;
   WORD    wAddress0,wAddress1,wAddress2;
   WORD    wAddress3,wAddress4,wAddress5;
   WORD    P16R16_BaseAddress[2];
   WORD    wP16R16No;

   wP16R16No=0;

   clrscr();  // a clear screen function in P16R16.LIB
   gotoxy(1,1);

   /* initiaing PCI-P16R16 card and detect how many P16R16/P8R8 card in PC */
   wRetVal=PCI_DriverInit(&wBoards);
   printf("Threr are %d PCI-P16R16/P8R8 Cards in this PC, Totally.\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P16R16/P8R8 card in this PC !!!\n");
      exit(0);
   }

   /* dump every P16R16/P8R8 card's configuration address space */
   for(i=0; i<wBoards; i++)
   {
      wRetVal=PCI_GetConfigAddressSpace(i,&wTypeID,
		     &wAddress0,&wAddress1,&wAddress2,
		     &wAddress3,&wAddress4,&wAddress5);
      if( !wRetVal )
      {
	  switch( wTypeID )
	  {
	     case 0:  printf("==> %02d   Board Name:PCI-P16R16\n",i);
		      P16R16_BaseAddress[wP16R16No++]=wAddress2;
		      break;
	     case 1:  printf("==> %02d   Board Name:PCI-P8R8\n",i);
		      break;
	     case 2:  printf("==> %02d   Board Name:PCI-TMC12\n",i);
		      break;
	     case 3:  printf("==> %02d   Board Name:PCI-DA16\n",i);
		      break;
	     case 4:  printf("==> %02d   Board Name:PCI-DA8\n",i);
		      break;
	  }
	  printf("  --> Addr0:%04x  |  Addr1:%04x  |  Addr2:%0x\n",
					wAddress0,wAddress1,wAddress2);
	  printf("  --> Addr3:%04x  |  Addr4:%04x  |  Addr5:%0x\n\n",
					wAddress3,wAddress4,wAddress5);
      }
   }

   /* Getting the Driver version */
   wRetVal=PCI_GetDriverVersion(&wVal);
   printf("Driver Version=%x\n",wVal);

   /* call a function to test if exact calling LIB */
   nVal=PCI_ShortSub2(1,2);
   printf("P180X_ShortSub2(1,2) = %d\n",nVal);

   /* call another function to test if exact calling LIB */
   fVal=PCI_FloatSub2(1.0,2.0);
   printf("P180X_FloatSub2(1.0,2.0) = %f\n",fVal);


   if( wP16R16No<2 )
   {
       putch(0x07);
       printf("Please plug two PCI-P16R16 card !\n");
       exit(0);
   }

   /*******************************************/
   /*****   First PCI-P16R16 DO/DO demo   *****/
   /*******************************************/
   printf("First PCI-P16R16 DO/DI testing !!!\n");
   P16R16_DO(P16R16_BaseAddress[0],0x0000);	/* Digital output */
   Delay(30000);     // Delay a little time
   wInData=P16R16_DI(P16R16_BaseAddress[0]);  /* Digital input	*/
   printf("Digital Output -> 0000H  |  Digital Input -> %04xH\n",wInData);

   P16R16_DO(P16R16_BaseAddress[0],0xFFFF);	/* Digital output */
   Delay(30000);     // Delay a little time
   wInData=P16R16_DI(P16R16_BaseAddress[0]);  /* Digital input	*/
   printf("Digital Output -> FFFFH  |  Digital Input -> %04xH\n",wInData);

   P16R16_DO(P16R16_BaseAddress[0],0x5555);	/* Digital output */
   Delay(30000);     // Delay a little time
   wInData=P16R16_DI(P16R16_BaseAddress[0]);  /* Digital input	*/
   printf("Digital Output -> 5555H  |  Digital Input -> %04xH\n",wInData);

   P16R16_DO(P16R16_BaseAddress[0],0xAAAA);	/* Digital output */
   Delay(30000);     // Delay a little time
   wInData=P16R16_DI(P16R16_BaseAddress[0]);  /* Digital input	*/
   printf("Digital Output -> AAAAH  |  Digital Input -> %04xH\n",wInData);

   /*******************************************/
   /*****  Second PCI-P16R16 DO/DO demo   *****/
   /*******************************************/
   printf("Second PCI-P16R16 DO/DI testing !!!\n");
   P16R16_DO(P16R16_BaseAddress[1],0x0000);	/* Digital output */
   Delay(30000);     // Delay a little time
   wInData=P16R16_DI(P16R16_BaseAddress[1]);  /* Digital input	*/
   printf("Digital Output -> 0000H  |  Digital Input -> %04xH\n",wInData);

   P16R16_DO(P16R16_BaseAddress[1],0xFFFF);	/* Digital output */
   Delay(30000);     // Delay a little time
   wInData=P16R16_DI(P16R16_BaseAddress[1]);  /* Digital input	*/
   printf("Digital Output -> FFFFH  |  Digital Input -> %04xH\n",wInData);

   P16R16_DO(P16R16_BaseAddress[1],0x5555);	/* Digital output */
   Delay(30000);     // Delay a little time
   wInData=P16R16_DI(P16R16_BaseAddress[1]);  /* Digital input	*/
   printf("Digital Output -> 5555H  |  Digital Input -> %04xH\n",wInData);

   P16R16_DO(P16R16_BaseAddress[1],0xAAAA);	/* Digital output */
   Delay(30000);     // Delay a little time
   wInData=P16R16_DI(P16R16_BaseAddress[1]);  /* Digital input	*/
   printf("Digital Output -> AAAAH  |  Digital Input -> %04xH\n",wInData);

   /**************************************************************/
   PCI_DriverClose();
   return 0;
}

Delay(int DelayTime)
{
   int	  i,j;
   float  a,b;

   for(i=0;  i<DelayTime; i++)
   {
      for(j=0; j<10; j++)
	 a=2*3.0;
   }
}
